using System;
using System.Windows;
using System.Windows.Data;

namespace Rhizome.Internal
{
    internal class BindingEvaluator : FrameworkElement
    {
        public object Value
        {
            get
            {
                Value = DependencyProperty.UnsetValue;
                SetBinding(ValueProperty, _binding);
                return GetValue(ValueProperty);
            }
            private set { SetValue(ValueProperty, value); }
        }

        static readonly DependencyProperty ValueProperty =
            DependencyProperty.Register("Value", typeof(object), typeof(BindingEvaluator), null);

        readonly Binding _binding;
        public BindingEvaluator(Binding binding)
        {
            _binding = binding;
        }
    }
}