using System;

namespace Rhizome.Model
{
    public class IfLessThen<T> : PropertyAndValueCriterionBase<T>
        where T : IComparable
    {
        public IfLessThen(string property, T value) : base(property, value)
        {
        }

        public IfLessThen(string property) : base(property)
        {
        }

        public IfLessThen()
        {
        }

        protected sealed override bool IsTrue(T value)
        {
            return value.CompareTo(Value) < 0;
        }
    }

	public sealed class IfLessThen : IfLessThen<IComparable>
	{
	}
}