using System;

namespace Rhizome.Model
{
    public class IfLessThenOrEquals<T> : PropertyAndValueCriterionBase<T>
        where T : IComparable
    {
        public IfLessThenOrEquals(string property, T value) : base(property, value)
        {
        }

        public IfLessThenOrEquals(string property) : base(property)
        {
        }

        public IfLessThenOrEquals()
        {
        }

        protected sealed override bool IsTrue(T value)
        {
            return value.CompareTo(Value) <= 0;
        }

    }

	public sealed class IfLessThenOrEquals: IfLessThenOrEquals<IComparable>
	{
		
	}
}