using System;

namespace Rhizome.Model
{
    public class IfMoreThen<T> : PropertyAndValueCriterionBase<T>
        where T : IComparable
    {
        public IfMoreThen(string property, T value) : base(property, value)
        {
        }

        public IfMoreThen(string property) : base(property)
        {
        }

        public IfMoreThen()
        {
        }

        protected sealed override bool IsTrue(T value)
        {
            return value.CompareTo(Value) > 0;
        }
    }

	public sealed class IfMoreThen : IfMoreThen<IComparable> {}
}