using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Windows.Markup;
using Rhizome.Contract;
using Rhizome.Contract.Visitor;
using Rhizome.Internal;

namespace Rhizome.Model
{
	[ContentProperty("Actions")]
	public abstract class ActionsItemBase<TPlant> : ItemBase<TPlant>
	{
		protected ActionsItemBase()
		{
			Actions = new RhizomeElementCollection<IAction>(this);
		}

		public Collection<IAction> Actions { get; private set; }

		protected void ProcessActions()
		{
			Actions.ForEach(action => action.Process());
		}

		#region Overrides of RhizomeElement

		protected override IEnumerable<IEnumerable> GetElementCollections()
		{
			return base.GetElementCollections().Concat(new[] {Actions});
		}

		#endregion
	}

	public abstract class ActionsItemBase : ActionsItemBase<object>
	{
	}
}