﻿using System;
using System.Diagnostics;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using System.Threading;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Rhizome.Contract;
using Rhizome.Model;

namespace Rhizome.Core.Test
{
	/// <summary>
	/// Summary description for ActiveObjectTest
	/// </summary>
	[TestClass]
	public class ActiveObjectTest
	{
		private readonly IActiveObjectHost _activeObjectHost = new ActiveObjectHost();

		public ActiveObjectTest()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		/// <summary>
		///Gets or sets the test context which provides
		///information about and functionality for the current test run.
		///</summary>
		public TestContext TestContext { get; set; }

		#region Additional test attributes
		//
		// You can use the following additional attributes as you write your tests:
		//
		// Use ClassInitialize to run code before running the first test in the class
		// [ClassInitialize()]
		// public static void MyClassInitialize(TestContext testContext) { }
		//
		// Use ClassCleanup to run code after all tests in a class have run
		// [ClassCleanup()]
		// public static void MyClassCleanup() { }
		//
		// Use TestInitialize to run code before running each test 
		// [TestInitialize()]
		// public void MyTestInitialize() { }
		//
		// Use TestCleanup to run code after each test has run
		// [TestCleanup()]
		// public void MyTestCleanup() { }
		//
		#endregion

		[TestInitialize]
		public void TestInit()
		{
			_activeObjectHost.Start();
		}

		[TestCleanup]
		public void TestCleanup()
		{
			_activeObjectHost.Dispose();
		}

		[TestMethod]
		public void EnsuareSynchronizationContextSendWorks()
		{
			var stopwatch = new Stopwatch();
			var taskTime = TimeSpan.FromSeconds(5);
			stopwatch.Start();
			_activeObjectHost.SynchronizationContext.Send(state => Thread.Sleep(taskTime), null);
			stopwatch.Stop();
			//var delta = stopwatch.Elapsed - taskTime;
			Assert.AreEqual(taskTime.TotalMilliseconds, stopwatch.ElapsedMilliseconds, 10, "Send time out");
		}
	}
}
